/************************************/
/*	Comp Arc Project
/*	By: Simon Foucher
/*	260 223 197
/************************************/


/************************************/
/*	includes and definitions				
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>






/************************************/
/*	Function declarations				
/************************************/


/************************************/
/*	Global Variables & datatypes				
/************************************/
#define TRUE 1
#define FALSE 0
typedef int BOOL;

/************************************/
/*	Functions						
/************************************/

// To clean up gathered strings from text
void stripCRLF(char array[])
{
    int i;

    for(i=0;i<500 && array[i]!='\0';i++)
      if (array[i]=='\r' || array[i]=='\n')
		array[i]='\0';
}


// To compute power
int power(int x, int n){

	if(n == 0)
		return 1;

	else{
		int tmp = power(x, n/2);
		if(n%2)
			return tmp*tmp*x;
		else
			return tmp*tmp; 
	}

}



void readTrace(FILE *fp, int Nbits)
{

	// Following arrays used to store statistical data (related elements share a common index)
	char addresses[100000][20];
	int predictorLocal[100000];								
	int totalBR = 0, totalGoodPredictions = 0;
	int Nmask, treshold;

	char temp[50];
	char tmpAddress[10];
	int i, j, k;
	int done;



/************************************ INITIALIZATION ************************************************/		

	// Format arrays with preditction not taken
	for(i = 0; i < 100000; i++){
		predictorLocal[i] = 0;
	}

	// Build bit mask for N bit predictor
	Nmask = power(2, Nbits);
	treshold = Nmask/2;


// DEBUGGING
// printf("N = %d\t2^N = %d\tMask: 0x%x\n", Nbits, Nmask+1,Nmask);



/************************************ DATA FETCH ************************************************/		
	// Extract lines of data; break at EOF
	while( fgets(temp, sizeof(temp), fp) != NULL ){

		stripCRLF(temp);								// Clean up the string
//printf("Line: %s", temp);		
		totalBR++;										// Increment total branch count
		

		for(i = 0; ; i++){								// Extract address of branch
			tmpAddress[i] = temp[i];
			if(tmpAddress[i] == ' ')
				break;
		}

		tmpAddress[i++] = NULL;							// Add a proper null terminator and increment index (i points at branch result)

		//for(;i<15; i++)
		//	printf("--temp[%d] = %d\n",i, temp[i]);



		for(k = 0; k < 100000; k++)						// Find out if the entry already exists
			if(addresses[k][0] == NULL || !strncmp(addresses[k], tmpAddress, 9))
				break;			

		if(k != 99999){									// If it is a new entry, k points at the first empt spot
			if(addresses[k][0] == NULL)
			strcpy(addresses[k], tmpAddress);
		}
		else
			printf("Warning! Reached end of buffer!!!!\n");




/************************************ PREDICTOR ************************************************/		
		/* At this point, i points at the branch result and k at the array index whete the element goes
		 NOTES: 
		 	* ASCII 48 = 0, 49 = 1
			* Example with 8 bits used for comments
			* The 4 cases evaluated are mutually exclusive (unlike in correlating predictor)		
		*/
//printf("pred Was: %x\t", predictorLocal[k]);

		// If predict "NOT taken
		// So predict Local is < 0001 0000 equivalent to Renge of [0000 0000, 0000 1111] 
		if(predictorLocal[k] < treshold){
			// If branch IS taken
			if(temp[i] == 49){
				totalGoodPredictions += 0;					// Bad prediction

				predictorLocal[k] +=1;						// Increment the predictor
				if(predictorLocal[k] == treshold)			// If we hit the turning point (0001 0000), jump to "strong taken"(1111 1111)
					predictorLocal[k] = Nmask - 1;			// Nmask = 1 0000 0000 so Nmask - 1 = 1111 1111 = strong taken
			}		
			// If branch NOT taken
			if(temp[i] == 48){
				totalGoodPredictions += 1;					// Good prediction
				if(predictorLocal[k] != 0)					// If predictor != 0000 0000
					predictorLocal[k] -= 1;					// Reflect last BR decision ourcome (LSB of 0)
				}
		}


		// If predict "IS taken"
		// If predictorLocal is in the range [0001 0000, 1111 1111]
		if(predictorLocal[k] >= treshold){
			// If branch IS taken
			if(temp[i] == 49){
				totalGoodPredictions += 1;					// Good prediction

				if(predictorLocal[k] != Nmask - 1)			// If predictor < 1 0000 0000 = Range og [0001 0000, 1111 1111]
					predictorLocal[k] += 1;					// increment by 1
			}		
			// If branch NOT taken
			if(temp[i] == 48){
				totalGoodPredictions += 0;					// Bad prediction
				predictorLocal[k] -= 1;						// Reflect last BR decision ourcome (LSB of 0)
		
				if(predictorLocal[k] == treshold - 1)		// If we got to 0000 1111
					predictorLocal[k] = 0;					// Jump to predict strong not taken 0000 0000
			}
		}

//printf("pred New: %x\t", predictorLocal[k]);
		if(predictorLocal[k] == Nmask)						// Avoid overflow (I don't think this is possible, but just in case...)
			predictorLocal[k]--;
//printf("pred Masked: %x\n", predictorLocal[k]);			
		

	}// End of while getting lines

/*/ Counts the number of different addresses
for(k=0;;k++)
	if(addresses[k][0] == NULL)
		break;
printf("K=%d\n",k);
*/


	printf("%d\t%d\t%d\t\t%d\n", Nbits, totalGoodPredictions, totalBR, totalGoodPredictions*100/totalBR);

	



	

}// End if readTrace




/*******************************************************************************/
/*	Function  main (int argc, char *argv[])
/*******************************************************************************/

int main (int argc, char *argv[])
{
	FILE *fp;
	int Nbits;

//FP had 430 different branch address
	printf("---------------------------------------------\n");
	// Open FP.trace
	if((fp = fopen("traces/FP.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open FP.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("FP.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");


	// Open INT.trace
	if((fp = fopen("traces/INT.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open INT.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("INT.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");



	// Open MM.trace
	if((fp = fopen("traces/MM.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open MM.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("MM.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");


//Server has 10 388 Different branch address

	// Open SERV.trace
	if((fp = fopen("traces/SERV.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open SERV.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("SERV.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");






}
