/************************************/
/*	Comp Arc Project
/*	By: Simon Foucher
/*	260 223 197
/************************************/


/************************************/
/*	includes and definitions				
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>






/************************************/
/*	Function declarations				
/************************************/


/************************************/
/*	Global Variables & datatypes				
/************************************/
#define TRUE 1
#define FALSE 0
typedef int BOOL;

/************************************/
/*	Functions						
/************************************/

// To clean up gathered strings from text
void stripCRLF(char array[])
{
    int i;

    for(i=0;i<500 && array[i]!='\0';i++)
      if (array[i]=='\r' || array[i]=='\n')
		array[i]='\0';
}


// To compute power
int power(int x, int n){

	if(n == 0)
		return 1;

	else{
		int tmp = power(x, n/2);
		if(n%2)
			return tmp*tmp*x;
		else
			return tmp*tmp; 
	}

}



void readTrace(FILE *fp, int Nbits, int tooBig)
{

	char addresses[1000][20];
	// 8 bits global predictor can represent 0d numbers ranging from [0,255]
	int predictorGlobal;

	// 8 198 x 255 is the largest array that can be declared in a 32 bits Linux machine without getting a segmentation fault.
	int predictorLocal[8100][256];									// Tha largest file is SERV which has 10 388 different addresses							
	int totalBR = 0, totalGoodPredictions = 0;
	int Nmask, treshold;
	char temp[50];
	char tmpAddress[11];
	int i, j, k;



//************************************ INITIALIZATION ************************************************	

	// Format arrays with preditction not taken
	predictorGlobal = 0;	
	for(i = 0; i < 8100; i++){
		for(k = 0; k < 256; k++)
				predictorLocal[i][k] = 0;
	}

	// Build bit mask for N bit predictor
	Nmask = power(2, Nbits);
	treshold = (Nmask)/2;




// DEBUGGING
// printf("N = %d\t2^N = %d\tMask: 0x%x\n", Nbits, Nmask+1,Nmask);



//************************************ DATA FETCH ************************************************	
	// Extract lines of data; break at EOF
	while( fgets(temp, sizeof(temp), fp) != NULL ){

		stripCRLF(temp);								// Clean up the string
//printf("Line: %s", temp);		
		totalBR++;										// Increment total branch count

		
		if(tooBig)										// If the address space is too big, skip the first digit
			k = 1;
		else
			k = 0;										// Otherwise copy the while string

		for(i = 0; ; i++, k++){								// Extract address of branch
			tmpAddress[i] = temp[k];
			if(tmpAddress[i] == ' ')
				break;
		}

		tmpAddress[i++] = NULL;							// Add a proper null terminator and increment index (i points at branch result)

		if(tooBig)
			i++;

		for(k = 0; k < 1000; k++)						// Find out if the entry already exists
			if(addresses[k][0] == NULL || !strncmp(addresses[k], tmpAddress, 10))
				break;			

		if(k != 8099){									// If it is a new entry, k points at the first empt spot
			if(addresses[k][0] == NULL)
			strcpy(addresses[k], tmpAddress);
		}
		else											// Warning if we busr out of memory
			printf("Warning! Reached end of buffer!!!!\n");




//************************************ PREDICTOR ************************************************		
		// At this point, i points at the branch result and k at the array index whete the element goes
		//  NOTES: 
		// 	ASCII 48 = 0, 49 = 1
		
//printf("pred Was: %x\t", predictorLocal[k]);

		// If predict "NOT taken
		// So predict Local is < 0001 0000 equivalent to Renge of [0000 0000, 0000 1111] 
		if(predictorLocal[k][predictorGlobal] < treshold){
			// If branch IS taken
			if(temp[i] == 49){
				// Update # of good predictions
				totalGoodPredictions += 0;								// Bad prediction

				// Update Local predictor & jump if reach treshold
				predictorLocal[k][predictorGlobal] +=1;					// Increment the predictor
				if(predictorLocal[k][predictorGlobal] == treshold)		// Hit turning point (0001 0000), jump to "strong taken"(1111 1111)
					predictorLocal[k][predictorGlobal] = Nmask - 1;		// Nmask = 1 0000 0000 so Nmask - 1 = 1111 1111 = strong taken
			
				// Update Global predictor if not at its max value
				if(predictorGlobal != 255)
					predictorGlobal++;
			}		

			// If branch NOT taken
			if(temp[i] == 48){
				// Update # of good predictions
				totalGoodPredictions += 1;								// Good prediction

				// Update Local predictor if we are not at edge value
				if(predictorLocal[k][predictorGlobal] != 0)				// If predictor != 0000 0000
					predictorLocal[k][predictorGlobal] -= 1;			// Reflect last BR decision ourcome (LSB of 0)
				}

				// Update Global predictor if not at its max value
				if(predictorGlobal != 255)
					predictorGlobal++;

		}


		// If predict "IS taken"
		// If predictorLocal is in the range [0001 0000, 1111 1111]
		if(predictorLocal[k][predictorGlobal] >= treshold){
			// If branch IS taken
			if(temp[i] == 49){
				// Update # of good predictions
				totalGoodPredictions += 1;								// Good prediction

				// Update Local predictor if we are not at edge value
				if(predictorLocal[k][predictorGlobal] != Nmask - 1)		// If predictor < 1 0000 0000 = Range og [0001 0000, 1111 1111]
					predictorLocal[k][predictorGlobal] += 1;			// increment by 1

				// Update Global predictor if not at its min value
				if(predictorGlobal != 0)
					predictorGlobal--;
			}		

			// If branch NOT taken
			if(temp[i] == 48){
				// Update # of good predictions
				totalGoodPredictions += 0;								// Bad prediction
				predictorLocal[k][predictorGlobal] -= 1;				// Reflect last BR decision ourcome (LSB of 0)

				// Update Local predictor & jump if reach treshold
				if(predictorLocal[k][predictorGlobal] == treshold - 1)	// If we got to 0000 1111
					predictorLocal[k][predictorGlobal] = 0;				// Jump to predict strong not taken 0000 0000

				// Update Global predictor if not at its min value
				if(predictorGlobal != 0)
					predictorGlobal--;
			}
		}

//printf("pred New: %x\t", predictorLocal[k]);
		if(predictorLocal[k][predictorGlobal] == Nmask)					// Avoid overflow
			predictorLocal[k][predictorGlobal]--;
		if(predictorGlobal == 256)
			predictorGlobal--;
//printf("pred Masked: %x\n", predictorLocal[k]);			
		

	}// End of while getting lines

	printf("%d\t%d\t%d\t\t%d\n", Nbits, totalGoodPredictions, totalBR, totalGoodPredictions*100/totalBR);

	

}// End if readTrace




/*******************************************************************************/
/*	Function  main (int argc, char *argv[])
/*******************************************************************************/

int main (int argc, char *argv[])
{
	FILE *fp;
	int Nbits;



	printf("---------------------------------------------\n");
	// Open FP.trace
	if((fp = fopen("traces/FP.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open FP.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("FP.trace Analysis\n");


	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits, 0);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");


	// Open INT.trace
	if((fp = fopen("traces/INT.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open INT.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("INT.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits, 0);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");



	// Open MM.trace
	if((fp = fopen("traces/MM.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open MM.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("MM.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits += 2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits, 0);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");



	// Open SERV.trace
	if((fp = fopen("traces/SERV.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open SERV.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("SERV.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits, 1);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");






}
