/************************************/
/*	Comp Arc Project
/*	By: Simon Foucher
/*	260 223 197
/************************************/


/************************************/
/*	includes and definitions				
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


#define TRUE 1
#define FALSE 0
typedef int BOOL;


/************************************/
/*	Function declarations				
/************************************/


/************************************/
/*	Global Variables & datatypes				
/************************************/


/************************************/
/*	Functions						
/************************************/

// To clean up gathered strings from text
void stripCRLF(char array[])
{
    int i;

    for(i=0;i<500 && array[i]!='\0';i++)
      if (array[i]=='\r' || array[i]=='\n')
		array[i]='\0';
}


void readTrace(FILE *fp)
{
	// Following arrays used to store statistical data (related elements share a common index)
	char addresses[10000][20];
	int frequency[10000];
	int taken[10000];
	int totalBR = 0, totalTak = 0;



	char temp[50];
	char tmpAddress[10];
	int i, j, k;

	// Format arrays
	for(i = 0; i < 10000; i++){
		frequency[i] = 0;
		taken[i] = 0;
	}
	



	// Extract lines of data; break at EOF
	while( fgets(temp, sizeof(temp), fp) != NULL ){

		stripCRLF(temp);								// Clean up the string
		//fputs(temp, stdout);
		totalBR++;
		

		for(i = 0; ; i++){								// Extract address of branch
			tmpAddress[i] = temp[i];
			if(tmpAddress[i] == ' ')
				break;
		}

		tmpAddress[i++] = NULL;							// Add a proper null terminator and increment index (i points at branch result)

		//for(;i<15; i++)
		//	printf("--temp[%d] = %d\n",i, temp[i]);



		for(k = 0; k < 10000; k++)						// Find out if the entry already exists
			if(addresses[k][0] == NULL || !strncmp(addresses[k], tmpAddress, 9))
				break;			

		if(k != 9999){									// If it is a new entry, k points at the first empt spot
			if(addresses[k][0] == NULL)
				//printf("\tNew Entry: %s \tat index: %d \t taken (if 1) '%c' \n\t", tmpAddress, k, temp[i]);
			strcpy(addresses[k], tmpAddress);
		}

		
		// At this point, i points at the branch result and k at the array index whete the element goes.
 		// record the statistics
		frequency[k]++;

		// ASCII 48 = 0, 49 = 1
		if(temp[i] == 49){
			taken[k] += 1;
			totalTak += 1;
		}

		//printf("\tAddress: %s, \t used: %d, \t Taken: %d\n", addresses[k], frequency[k], taken[k]);


	}// End of while getting lines

	fclose(fp);

	printf("\n DONE!!\n\nResults:\n");

/*	for(k = 0; k < 9999; k++){
		if(addresses[k][0] == NULL)
			break;
		printf("k: %d\t Add: %s\tTaken: %d\tFreq: %d\tRatio: %d\n", k, addresses[k], taken[k], frequency[k], taken[k]*100/frequency[k]);
	}
*/
	printf("\n\nTotal BR: %d\tTaken: %d\tRatio: %d%\n\n",totalBR, totalTak, totalTak*100/totalBR);
	printf("---------------------------------------------\n");
	


}// End if readTrace




/*******************************************************************************/
/*	Function  main (int argc, char *argv[])
/*******************************************************************************/

int main (int argc, char *argv[])
{
	FILE *fp;

	// FP.trace
	if((fp = fopen("traces/FP.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open FP.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("Sucessfully opened FP.trace\nStarting analysis\n");

	readTrace(fp);


	// INT.trace
	if((fp = fopen("traces/INT.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open INT.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("Sucessfully opened INT.trace\nStarting analysis\n\n");

	readTrace(fp);


	// MM.trace
	if((fp = fopen("traces/MM.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open MM.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("Sucessfully opened MM.trace\nStarting analysis\n\n");

	readTrace(fp);


	// SERV.trace
	if((fp = fopen("traces/SERV.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open SERV.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("Sucessfully opened SERV.trace\nStarting analysis\n\n");

	readTrace(fp);








}
