/************************************/
/*	Comp Arc Project
/*	By: Simon Foucher
/*	260 223 197
/************************************/


/************************************/
/*	includes and definitions				
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>






/************************************/
/*	Function declarations				
/************************************/


/************************************/
/*	Global Variables & datatypes				
/************************************/
#define TRUE 1
#define FALSE 0
typedef int BOOL;

/************************************/
/*	Functions						
/************************************/

// To clean up gathered strings from text
void stripCRLF(char array[])
{
    int i;

    for(i=0;i<500 && array[i]!='\0';i++)
      if (array[i]=='\r' || array[i]=='\n')
		array[i]='\0';
}


// To compute power
int power(int x, int n){

	if(n == 0)
		return 1;

	else{
		int tmp = power(x, n/2);
		if(n%2)
			return tmp*tmp*x;
		else
			return tmp*tmp; 
	}

}



void readTrace(FILE *fp, int Nbits)
{
	// Data gathering variables & common
	char addresses[8000][20];
	char temp[50];
	char tmpAddress[10];
	int i, j, k;

	// Buffer (n bit) Predictor data
	int BufferPredictor[8000];								
	int NmaskBuffer, tresholdBuffer;
	int bufferPrediction;

	// Correlating Predictor data
	int predictorGlobal;
	int correlatingPredictor[1000][255];
	int NmaskCorrelator, tresholdCorrelator;
	int correlatorPrediction;

	// Chooser table
	int chooser[8000];

	// Statistical variables
	int totalBR = 0, totalGoodPredictions = 0;





/************************************ INITIALIZATION ************************************************/		

	// Format arrays with preditction not taken
	predictorGlobal = 0;	
	for(i = 0; i < 8000; i++){
		BufferPredictor[i] = 0;									// Buffer predictor
		chooser[i] = 0;											// Chooser
		for(k = 0; k < 256; k++)
				correlatingPredictor[i][k] = 0;					// Correlating predictor
	}

	// Build bit mask for predictors
	NmaskBuffer = power(2, Nbits);
	tresholdBuffer = NmaskBuffer/2;

	NmaskCorrelator = power(2, Nbits);
	tresholdCorrelator = (NmaskCorrelator)/2;





/************************************ DATA FETCH ************************************************/		
	// Extract lines of data; break at EOF
	while( fgets(temp, sizeof(temp), fp) != NULL ){

		stripCRLF(temp);								// Clean up the string
//printf("Line: %s", temp);		
		totalBR++;										// Increment total branch count
		

		for(i = 0; ; i++){								// Extract address of branch
			tmpAddress[i] = temp[i];
			if(tmpAddress[i] == ' ')
				break;
		}

		tmpAddress[i++] = NULL;							// Add a proper null terminator and increment index (i points at branch result)

		//for(;i<15; i++)
		//	printf("--temp[%d] = %d\n",i, temp[i]);



		for(k = 0; k < 8000; k++)						// Find out if the entry already exists
			if(addresses[k][0] == NULL || !strncmp(addresses[k], tmpAddress, 9))
				break;			

		if(k != 7999){									// If it is a new entry, k points at the first empt spot
			if(addresses[k][0] == NULL)
			strcpy(addresses[k], tmpAddress);
		}
		else
			printf("Warning! Reached end of buffer!!!!\n");




/************************************ BUFFER PREDICTOR ************************************************/		

		// If predict "NOT taken
		// So predict Local is < 0001 0000 equivalent to Renge of [0000 0000, 0000 1111] 
		if(BufferPredictor[k] < tresholdBuffer){
			bufferPrediction = 0;									// Save result of the prediction
			// If branch IS taken
			if(temp[i] == 49){
				BufferPredictor[k] +=1;								// Increment the predictor
				if(BufferPredictor[k] == tresholdBuffer)			// Hit the turning point (0001 0000), jump to "strong taken"(1111 1111)
					BufferPredictor[k] = NmaskBuffer - 1;			// NmaskBuffer = 1 0000 0000 so NmaskBuffer - 1 = 1111 1111 = strong taken
			}		
			// If branch NOT taken
			if(temp[i] == 48){
				if(BufferPredictor[k] != 0)							// If predictor != 0000 0000
					BufferPredictor[k] -= 1;						// Reflect last BR decision ourcome (LSB of 0)
				}
		}


		// If predict "IS taken"
		// If BufferPredictor is in the range [0001 0000, 1111 1111]
		if(BufferPredictor[k] >= tresholdBuffer){
			bufferPrediction = 1;									// Save result of the prediction

			// If branch IS taken
			if(temp[i] == 49){
				if(BufferPredictor[k] != NmaskBuffer - 1)			// If predictor < 1 0000 0000 = Range og [0001 0000, 1111 1111]
					BufferPredictor[k] += 1;						// increment by 1
			}		
			// If branch NOT taken
			if(temp[i] == 48){
				BufferPredictor[k] -= 1;							// Reflect last BR decision ourcome (LSB of 0)
		
				if(BufferPredictor[k] == tresholdBuffer - 1)		// If we got to 0000 1111
					BufferPredictor[k] = 0;							// Jump to predict strong not taken 0000 0000
			}
		}


		if(BufferPredictor[k] == NmaskBuffer)						// Avoid overflow (I don't think this is possible, but just in case...)
			BufferPredictor[k]--;






//************************************ CORRELATING PREDICTOR ************************************************		

		// If predict "NOT taken
		// So predict Local is < 0001 0000 equivalent to Renge of [0000 0000, 0000 1111] 
		if(correlatingPredictor[k][predictorGlobal] < tresholdCorrelator){
			correlatorPrediction = 0;									// Save result
			// If branch IS taken
			if(temp[i] == 49){
				// Update Local predictor & jump if reach tresholdCorrelator
				correlatingPredictor[k][predictorGlobal] +=1;							// Increment the predictor
				if(correlatingPredictor[k][predictorGlobal] == tresholdCorrelator)		// Hit turning point (0001 0000), jump to "strong taken"(1111 1111)
					correlatingPredictor[k][predictorGlobal] = NmaskCorrelator - 1;		// NmaskCorrelator = 1 0000 0000 so NmaskCorrelator - 1 = 1111 1111 = strong taken
			
				// Update Global predictor if not at its max value
				if(predictorGlobal != 255)
					predictorGlobal++;
			}		

			// If branch NOT taken
			if(temp[i] == 48){
				// Update Local predictor if we are not at edge value
				if(correlatingPredictor[k][predictorGlobal] != 0)				// If predictor != 0000 0000
					correlatingPredictor[k][predictorGlobal] -= 1;			// Reflect last BR decision ourcome (LSB of 0)
				}

				// Update Global predictor if not at its max value
				if(predictorGlobal != 255)
					predictorGlobal++;
		}


		// If predict "IS taken"
		// If correlatingPredictor is in the range [0001 0000, 1111 1111]
		if(correlatingPredictor[k][predictorGlobal] >= tresholdCorrelator){
			correlatorPrediction = 1;										// Save result
			// If branch IS taken
			if(temp[i] == 49){
				// Update Local predictor if we are not at edge value
				if(correlatingPredictor[k][predictorGlobal] != NmaskCorrelator - 1)		// If predictor < 1 0000 0000 = Range og [0001 0000, 1111 1111]
					correlatingPredictor[k][predictorGlobal] += 1;			// increment by 1

				// Update Global predictor if not at its min value
				if(predictorGlobal != 0)
					predictorGlobal--;
			}		

			// If branch NOT taken
			if(temp[i] == 48){
				correlatingPredictor[k][predictorGlobal] -= 1;				// Reflect last BR decision ourcome (LSB of 0)

				// Update Local predictor & jump if reach tresholdCorrelator
				if(correlatingPredictor[k][predictorGlobal] == tresholdCorrelator - 1)	// If we got to 0000 1111
					correlatingPredictor[k][predictorGlobal] = 0;				// Jump to predict strong not taken 0000 0000

				// Update Global predictor if not at its min value
				if(predictorGlobal != 0)
					predictorGlobal--;
			}
		}


		if(correlatingPredictor[k][predictorGlobal] == NmaskCorrelator)					// Avoid overflow
			correlatingPredictor[k][predictorGlobal]--;
		if(predictorGlobal == 256)
			predictorGlobal--;



//************************************** CHOOSER *****************************************************
// Here, 'bufferPrediction' and 'correlatorPrediction' contain the predict results of both algorithms
// The branch result is evaluating a second time (redundent, but we are not aiming for performance)
// The chooser are 2 bit numbers, ranginf from 00 = 0 to 11 = 3. Their treshold is 2.
// Chooser 0,1 prefers Buffer
// Chooser 2,3 prefers Correlator

	switch(chooser[k]) {
		// case 0, 1 select Buffer predictor
		case 0:
			if(temp[i] == 49){					// If branch IS taken
				if(bufferPrediction == 1)		// Predict IS taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
				if(bufferPrediction == 0)		// Predict NOT taken
					chooser[k] = 1;				// Bad prediction = Update chooser
			}		
			if(temp[i] == 48){					// If branch NOT taken
				if(bufferPrediction == 1)		// Predict IS taken
					chooser[k] = 1;				// Bad prediction = Update chooser
				if(bufferPrediction == 0)		// Predict NOT taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
			}
			break;

		case 1:
			if(temp[i] == 49){					// If branch IS taken
				if(bufferPrediction == 1){		// Predict IS taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 0;				// Good prediction = update chooser to stable
				}
				if(bufferPrediction == 0)		// Predict NOT taken
					chooser[k] = 3;				// Bad prediction = Update chooser
			}		
			if(temp[i] == 48){					// If branch NOT taken
				if(bufferPrediction == 1)		// Predict IS taken
					chooser[k] = 3;				// Bad prediction = Update chooser
				if(bufferPrediction == 0){		// Predict NOT taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 0;				// Good prediction = update chooser to stable
				}
			}
			break;

		// case 2,3 select correlating predictor
		case 2:
			if(temp[i] == 49){					// If branch IS taken
				if(correlatorPrediction == 1){	// Predict IS taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 3;				// Good prediction = update chooser to stable
				}
				if(correlatorPrediction == 0)	// Predict NOT taken
					chooser[k] = 0;				// Bad prediction = Update chooser
			}		
			if(temp[i] == 48){					// If branch NOT taken
				if(correlatorPrediction == 1)	// Predict IS taken
					chooser[k] = 0;				// Bad prediction = Update chooser
				if(correlatorPrediction == 0){	// Predict NOT taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 3;				// Good prediction = update chooser to stable
				}
			}
			break;


		case 3:
			if(temp[i] == 49){					// If branch IS taken
				if(correlatorPrediction == 1){	// Predict IS taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 3;				// Good prediction = update chooser to stable
				}
				if(correlatorPrediction == 0)	// Predict NOT taken
					chooser[k] = 2;				// Bad prediction = Update chooser
			}		
			if(temp[i] == 48){					// If branch NOT taken
				if(correlatorPrediction == 1)	// Predict IS taken
					chooser[k] = 2;				// Bad prediction = Update chooser
				if(correlatorPrediction == 0){	// Predict NOT taken
					totalGoodPredictions++;		// Good prediction = update good prediction counter
					chooser[k] = 3;				// Good prediction = update chooser to stable
				}
			}
			break;
		default:
			break;
	}// End of switch chooser

	}// End of while getting lines


	printf("%d\t%d\t%d\t\t%d\n", Nbits, totalGoodPredictions, totalBR, totalGoodPredictions*100/totalBR);

	



	

}// End if readTrace




/*******************************************************************************/
/*	Function  main (int argc, char *argv[])
/*******************************************************************************/

int main (int argc, char *argv[])
{
	FILE *fp;
	int Nbits;


	printf("---------------------------------------------\n");
	// Open FP.trace
	if((fp = fopen("traces/FP.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open FP.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("FP.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");


	// Open INT.trace
	if((fp = fopen("traces/INT.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open INT.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("INT.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");



	// Open MM.trace
	if((fp = fopen("traces/MM.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open MM.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("MM.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");



	// Open SERV.trace
	if((fp = fopen("traces/SERV.trace","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open SERV.trace\n"		
				 "Please make sure it is located in a directory called 'traces/'\n"
				 "having this program's directory as a root\n");
		}
	else
		printf("SERV.trace Analysis\n");

	printf("Nbits\tGoodPr\tTotBR\t\tAccuracy(%)\n");
	for(Nbits = 2; Nbits <=20; Nbits +=2){
		rewind(fp);												// Rewind file pointer
		readTrace(fp, Nbits);
	}

	fclose(fp);
	printf("\n---------------------------------------------\n");






}
